/*global define, CKEDITOR, setTimeout*/
/*jslint regexp: true, unparam: true*/
define(['testsuite/qunit', 'jquery', 'ep/ui/editor', '$ready!'], function (QUnit, $) {
    'use strict';

    QUnit.module("ckeditor/plugins/eppagebreak");

    var editor1 = $('#uieditor_ckeditortestinstance_test1');

    function cke_test(setfunction, testfunction, editorId, editorClass) {
        var editorInstance = CKEDITOR.instances[editorId];

        // reset CKE data
        editorInstance.setData('abc');
        // test if eppagebutton is available
        QUnit.ok($('.' + editorClass + ' .cke_button__eppagebreak').length === 1, 'page break button is available');

        // set focus
        editorInstance.focus();

        setTimeout(function () {
            setfunction();

            setTimeout(function () {
                QUnit.equal($('.' + editorClass + ' .cke_dialog').is(':visible'), false, 'table dialog closed');

                setTimeout(function () {
                    var data = editorInstance.getData();

                    testfunction(data);
                    QUnit.start();
                }, 200);

            }, 200);

        }, 1000);
    }

    // instantiate CKE
    editor1.uiEditor({
        'name' : 'ckeditortestinstance_test1',
        'toolbar': 'Full',
        'blogPostMode': true
    });

    setTimeout(function () {

        QUnit.asyncTest("basic table plugin tests", function () {
            var editorId = 'uieditor_ckeditortestinstance_test1',
                editorClass = 'cke_1',
                editorInstance = CKEDITOR.instances[editorId];

            cke_test(function () {
                // insert page break
                $('.' + editorClass + ' .cke_button__eppagebreak').trigger('click');
            }, function (data) {
                var expected = /<!-- more -->/,
                    fakeElement;

                QUnit.ok(data.search(expected) !== -1, 'page break was inserted to textarea');

                // get fake element for page break from iframe
                fakeElement = $(editorInstance.document.$.body).find('img.ckePageBreak');

                QUnit.ok(fakeElement.length === 1, 'fakeElement to diaplay page break in WYSIWYG was inserted');
            }, editorId, editorClass);
        });

    }, 2000);
});